/*                  GTAV BUS MOD SCRIPTHOOKVDOTNET   
             THIS MOD ADD BUS MISSION TO THE WORLD OF GTAV
                   Copyright (C) 2015 Charbel Harb

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA


   Author contact: c@lebane.se

*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using GTA;
using GTA.Native;
using GTA.Math;
using NativeUI;
using System.IO;

namespace bus_mod
{
    class bus_mod : Script

    {
        Mission _mis = new Mission();
        private MenuPool menu_p;
        private string keycode = _get_key();//control
        private UIMenu main_m;
        public static bool _lock = false; //used to disable clicking start several times
        public static dynamic mission = get_first_child();
        
        //get default key -control-
        private static string _get_key()

        {
            string key = "";
            string path =@"scripts\\bus_mod.ini";
            try
            {


                using (StreamReader r = new StreamReader(path))
                {
                    key = r.ReadLine();
                    r.Close();
                }
            }
            catch (Exception e)
            {
                UI.ShowSubtitle(e.Message);
            }

            string[] _key_ = key.Split('=');
            return _key_[1].ToString();

        }

        //adding mission name for the nativeui list
        private static List<dynamic> _get_mission_name()
        {
            List<dynamic> _mission_name = new List<dynamic>();

            try
            {


                string path =  @"scripts\\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes("/missions/element/name");
                
                foreach (XmlNode _node in n_list)
                {

                    _mission_name.Add(_node.InnerText);
                }

                f_s.Close();

            } 

            catch (Exception e)
            {
                UI.ShowSubtitle(e.Message);
            }
            
            return _mission_name;

        }

        //returning first mission
        public static string get_first_child()
        {

            List<dynamic> _mission_name = new List<dynamic>();
            _mission_name = _get_mission_name();
            return _mission_name[0];
        }



        //constructor
        public bus_mod()

        {
            Interval = 0;
            UI.Notify("Bus mod loaded - scorz");
            menu_p = new MenuPool();
            Tick += (o, e) => {
               
                menu_p.ProcessMenus();
                if (_lock) { _mis._check(); };

            };

            KeyDown += (o, e) =>
            {
                if (e.KeyCode.ToString() == keycode.ToString() && !menu_p.IsAnyMenuOpen())
                    this.s_menu();
            };

        }

        
        //menu
        private UIMenu s_menu()

        {
            main_m = new UIMenu("", "Bus mod by scorz");
            menu_p.Add(main_m);
            List<dynamic> mission_name = _get_mission_name();
            var start_but = new UIMenuItem("Start", "Click to start mission.");
            main_m.AddItem(start_but);
            var _mission_list = new UIMenuListItem("Missions List", mission_name, 0, "Choose mission");
            main_m.AddItem(_mission_list);
            var _cancel = new UIMenuItem("Cancel", "Cancel current mission");
            _cancel.Enabled = false;
            main_m.AddItem(_cancel);

            if (_lock)
            {
                start_but.Enabled = false;
                _mission_list.Enabled = false;
                _cancel.Enabled = true;
                
            }
            main_m.SetBannerType("scripts\\bus_mod.png");
            main_m.OnItemSelect += OnItemSelect;
            main_m.OnListChange += OnListChange;
            main_m.RefreshIndex();
            main_m.Visible = !main_m.Visible;
            return main_m;

        }



        //when user change mission list
        public void OnListChange(UIMenu sender, UIMenuListItem listitem, int index)
        {
            if(sender == main_m)
            {
               mission = listitem.IndexToItem(index);
            }

        }


        //click start
        public void OnItemSelect(UIMenu sender, UIMenuItem selecteditem, int index)
        {
            if (sender == main_m)
            {

           
                switch(index)
                {

                    case 0:
                        _lock = true;
                        menu_p.CloseAllMenus();
                        _mis.prepare_mission(mission);
                       
                       
                      
                        break;
                    
                    case 2:
                        
                        menu_p.CloseAllMenus();
                        _mis.cancel_mission();
                        _lock = false;

                        break;

                
            }
            }
        }

    }
}
