/*  THIS FILE IS A PART OF GTAV BUS MOD SCRIPTHOOKVDOTNET
                   c@lebane.se
        Copyright (C) 2015 Charbel Harb
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Xml;
using System.Windows.Forms;
using NativeUI;
using GTA;
using GTA.Native;
using GTA.Math;


namespace bus_mod
{
    class Mission
    {
       
       
        List<Ped> _ped = new List<Ped>();//put all passengers here
        Blip destination;
        string mission = "";
        Vehicle coach;
        int _player = 0;//rel group
        int _magic = 0;//same as above

       

        public Mission() {

            
            //

        }

        //method on Tick - on only when in mission
        public void _check()
        {
           
            Ped player = Game.Player.Character;
        
            //condition to prevent destruction of vehicle before player uses it
            if(player.IsInVehicle(coach))

                {
                coach.IsInvincible = false;
            }
           

           //auto cancel if veh destroyed or pass die
             if(    !(are_all_passengers_alive()) || !(coach.IsAlive) )

            {
                bus_mod._lock = false;
                cancel_mission(0);
                
                
            }
            //show route to destination on map
            if (are_all_passengers_on_veh())

            {
                destination.ShowRoute = true;
            }

            //driver arrives to pick up pass
            if (coach.Position.DistanceTo(_ped[0].Position) <= 30.0 && coach.IsStopped && Game.IsControlPressed(2, GTA.Control.VehicleHorn))
            {
                rem_invi();
                for (int i = 0; i < _ped.Count; i++)
                {
                    _ped[i].SetIntoVehicle(coach, VehicleSeat.Any);

                }
                UI.ShowSubtitle("Come on, get in!");
               

            }

            //driver arrives to destination
            if (coach.Position.DistanceTo(destination.Position) <= 30.0 && coach.IsStopped && Game.IsControlPressed(2, GTA.Control.VehicleHorn))
            {

                for (int i = 0; i < _ped.Count; i++)
                {

                    _ped[i].Position = coach.Position.Around(5);

                }
                UI.ShowSubtitle("Ok we're here. Thanks for using Dashound Bus Center.", 4000);
               
                coach.MarkAsNoLongerNeeded();
                destination.Remove();
                remove_ped_blip();
                coach.CurrentBlip.Remove();
                destination.ShowRoute = false;
                
                no_longer_needed();
                bus_mod._lock = false;


            }
        }



            
        //are all passenger alive?
        private bool are_all_passengers_alive()
        {
            for (int i = 0; i < _ped.Count; i++)
            {
                if (!((_ped[i]).IsAlive))
                {
                    return false;
                }

            }
            return true;
        }

        //are all passenger in veh?
           private bool are_all_passengers_on_veh()
        {

            for(int i=0;i<_ped.Count;i++)
            {

                if(!(_ped[i].IsInVehicle(coach)))
                {
                    return false;
                }
                    
                }
            return true;

        }
        
       
        //reading mission description from xml file
        private string get_desc(string mission)

        {

            try
            {

                string desc_str = "";
                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                _xml_doc.Load(path);
                XmlNode desc = _xml_doc.SelectSingleNode("/missions/element[name='" + mission + "']/description");
                desc_str = desc.InnerText.ToString();
                f_s.Close();
                return desc_str;

            }

            catch (Exception)

            {
                UI.ShowSubtitle("GET_DESC_ERROR");
            }

            return "";
        }


        //how many ped do we have in the mission?
        private int get_ped_number()
        {
            try
            {


                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes("/missions/element[name='" + mission + "']/ped");
                f_s.Close();
                return n_list.Count;
            }
            catch (Exception)
            {
                UI.ShowSubtitle("GET_PED_NUMBER_EROOR");
                return -1;
            }

        }

        //how much will we earn?
        private int get_money()

        {

            try
            {
                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes("/missions/element[name='" + mission + "']/money");
                f_s.Close();
                return int.Parse(n_list[0].InnerText);

            }
            catch (Exception)
            {
                UI.ShowSubtitle("GET_MONEY_ERROR");
                return -1;
            }
        }

        //destination blip
        private void add_destination_blip()

        {

            try
            {


                destination = GTA.World.CreateBlip(new Vector3(get_co("destination", 0, 'x'), get_co("destination", 0, 'y'), get_co("destination", 0, 'z')));
                destination.Color = BlipColor.Blue;

            }

            catch (Exception)
            {
                UI.ShowSubtitle("ADD_DESTINATION_ERROR");
            }
        }

        //reading the xml and creating our ped
        private void generate_ped(int count)
        {
            try
            {


                for (int i = 0; i < count; i++)

                {
                    _ped.Add(GTA.World.CreatePed(new Model(get_hash("ped", i)), new GTA.Math.Vector3(get_co("ped", i, 'x'), get_co("ped", i, 'y'), get_co("ped", i, 'z')), get_co("ped", i, 't')));

                }
            }
            catch (Exception)
            {
                UI.ShowSubtitle("GENERATE_PED_ERROR");
            }


        }

        //adding ped blip
        private void add_ped_blip()
        {



            for (int i = 0; i < _ped.Count; i++)
            {

                _ped[i].AddBlip();

            }

        }

        //overload for future use - peds want to kill you-
        private void add_ped_blip(int index)

        {

            _ped[index].AddBlip();

        }

        //adding blip sprite
        private void add_ped_blip_sprite(BlipSprite sprite)
        {

            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].CurrentBlip.Sprite = sprite;
            }
        }

        //overload for future use - peds want to kill you
        private void add_ped_blip_sprite(int index, BlipSprite sprite)
        {

            _ped[index].CurrentBlip.Sprite = sprite;

        }

        //showing peds route
        private void ped_blip_show_route()
        {
            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].CurrentBlip.ShowRoute = true;
            }

        }

        //removing peds route
        private void ped_blip_remove_route()
        {
            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].CurrentBlip.ShowRoute = false;
            }

        }

        //overload for future use
        private void ped_blip_remove_route(int i)
        {
          
                _ped[i].CurrentBlip.ShowRoute = false;
           

        }

        //deleting peds
        private void remove_ped()
        {
            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].CurrentBlip.Remove();
                _ped[i].Delete();


            }
        }

        //overload deleting ped for future use
        private void remove_ped(int index)
        {


            _ped[index].CurrentBlip.Remove();
            _ped[index].Delete();

        }

        //removing peds blip
        private void remove_ped_blip()
        {

            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].CurrentBlip.Remove();
            }
        }

        //overload fo future use
        private void remove_ped_blip(int index)
        {

            _ped[index].CurrentBlip.Remove();

        }

      
        //reading from xml hashes
        private int get_hash(string element, int index)
        {
            try
            {


                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes(@"/missions/element[name='" + mission + "']/" + element + "/hash");
                f_s.Close();
                return int.Parse(n_list[index].InnerText);
            }

            catch (Exception)
            {
                UI.ShowSubtitle("GET_HASH_ERROR");
            }
            return -1;
        }

        //testing purpose added after changing xml (veh return string name not int) maybe it helps solve problem?
        private string get_veh_hash(string element, int index)
        {
            try
            {


                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes(@"/missions/element[name='" + mission + "']/" + element + "/hash");
                f_s.Close();
                return (n_list[index].InnerText);
            }

            catch (Exception)
            {
                UI.ShowSubtitle("GET_HASH_ERROR");
            }
            return "s";
        }

        //reading xml return coordinates/heading
        private float get_co(string element, int index, char coord)
        {

            try
            {


                string path = Directory.GetCurrentDirectory() + @"\scripts\bus_mod_missions.xml";
                FileStream f_s = new FileStream(path, FileMode.Open, FileAccess.Read);
                XmlDocument _xml_doc = new XmlDocument();
                XmlNodeList n_list;
                _xml_doc.Load(f_s);
                n_list = _xml_doc.SelectNodes(@"/missions/element[name='" + mission + "']/" + element + "/position/" + coord);
                f_s.Close();
                return float.Parse(n_list[index].InnerText);
            }


            catch (Exception)
            {
                UI.ShowSubtitle("GET_CO_ERROR" + element + " " + index + " " + coord + " ");
            }

            return 100000;
        }

        //canceling mission
        public void cancel_mission()

        {

            Ped player = Game.Player.Character;
            UI.ShowSubtitle("MISSION CANCELED ALL YOU HAD TO DO WAS TAKE THEM TO THE DAMN DESTINATION!", 8000);
            remove_ped_blip();
            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].Position.Around(3);
            }
            Game.Player.Character.Money -= get_money();
            destination.Remove();
            coach.CurrentBlip.Remove();
            coach.MarkAsNoLongerNeeded();
            no_longer_needed();
            destination.ShowRoute = false;
        }

        //overload for cancel mission if veh or ped is dead
        public void cancel_mission(int k)

        {

            Ped player = Game.Player.Character;
            UI.ShowSubtitle("ALL YOU HAD TO DO WAS TAKE THEM TO THE DAMN DESTINATION!", 3500);
            Script.Wait(3500);
            UI.ShowSubtitle("YOU'RE USELESS AS A CORPSE'S DICK!", 3500);
            remove_ped_blip();
            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].Position.Around(3);
            }
            Game.Player.Character.Money -= get_money();
            destination.Remove();
            coach.CurrentBlip.Remove();
            coach.MarkAsNoLongerNeeded();
            no_longer_needed();
            destination.ShowRoute = false;

        }

        //adding relationship to avoid passenger freaking out
        public void add_relationship()
        {
            Ped player = Game.Player.Character;
            _player = World.AddRelationshipGroup("Player");
            _magic = World.AddRelationshipGroup("Magic");
            World.SetRelationshipBetweenGroups(Relationship.Respect, _player, _magic);
            World.SetRelationshipBetweenGroups(Relationship.Respect, _magic, _player);
            player.RelationshipGroup = _player;
            for (int i = 0; i < _ped.Count; i++)
            {

                _ped[i].RelationshipGroup = _magic;
            }
        }

        //bye bye
        public void no_longer_needed()
        {

            for (int i = 0; i < _ped.Count; i++)
            {

                _ped[i].MarkAsNoLongerNeeded();
            }

        }

        //god mod passengers
        public void add_invi()
        {
            for (int i = 0; i < _ped.Count; i++)

            {

                _ped[i].IsInvincible = true;
            }

        }

        //!god mod passengers
        public void rem_invi()
        {

            for (int i = 0; i < _ped.Count; i++)
            {
                _ped[i].IsInvincible = false;
            }

        }

        //preparing
        public void prepare_mission(String _mission)

        {
            mission = _mission;
            bus_mod.mission = bus_mod.get_first_child();//reset list selection in menu

            if (_ped.Count > 1)
            {
                _ped.Clear(); //clear the ped list from previous version
                              //when used ped.clear in _check() scripts stop working and got stuck in an infinite loop
            }

            try
            {

                //echo description
                string desc = get_desc(mission);
                List<string> sub_u = desc.Split('^').ToList();
                for (int i = 0; i < sub_u.Count; i++)
                {

                    UI.ShowSubtitle(sub_u[i], 4000);
                    Script.Wait(4000);
                }



                try
                {
                    generate_ped(get_ped_number());//pass
                    add_invi();//god
                }
                catch (Exception)
                {

                    UI.ShowSubtitle("GENERATE_PED_ERROR");
                }

                add_ped_blip();//blip
                add_destination_blip();//dest
                add_ped_blip_sprite(BlipSprite.Friend);//spr

                try
                {

                    coach = GTA.World.CreateVehicle(new Model(get_veh_hash("vehicle", 0)), new Vector3(get_co("vehicle", 0, 'x'), get_co("vehicle", 0, 'y'), get_co("vehicle", 0, 'z')), get_co("vehicle", 0, 't'));//creating our veh
                    coach.AddBlip();
                    coach.CurrentBlip.Sprite = BlipSprite.Cab;
                    coach.CurrentBlip.ShowRoute = true;
                    coach.IsInvincible = true;//to prevent damage and mission auto-cancel before arriving 
                }

                catch (Exception)
                { UI.ShowSubtitle("VEHICLE_ERROR"); }
            }
            catch (Exception)
            {

                UI.ShowSubtitle("PREPARE_MISSION_ERROR");
            }


            add_relationship();//relationship

        }

    }
   

}
